<?php

class RouteeLogs {
    /**
     * @var
     */
    private $logdata;

    /**
     * @var
     */
    private $code;

    /**
     * @var
     */
    private $mode;

    /**
     * @param $mode
     * @param $code
     * @param $logdata
     */
    public function __construct($mode, $code, $logdata) {
		$this->mode = $mode;
		$this->code = $code; 
		$this->logdata = $logdata;

		$this->saveLogs();
        $this->sendErrorLog();
	}

    /**
     * @return void
     */
	public function saveLogs() {
		$table = _DB_PREFIX_ . 'store_events_logs';
        $isExported = Configuration::get('routee_log_exported') ?? 0;
        $logType = ($this->code == 200) ? 1 : 0;
        $data = json_encode($this->logdata);
        $url = _PS_BASE_URL_.__PS_BASE_URI__;
        $query = "INSERT INTO ".$table." (store_url,log_type,event_type,log_data,is_exported,created_at) VALUES ('$url','{$logType}','{$this->eventType()}','{$data}','{$isExported}',NOW())";

        Db::getInstance()->execute($query);
	}

    /**
     * @return void
     */
    public function sendErrorLog() {

        if($this->code != 200) {

            $postArr = array(
                'siteUrl' => _PS_BASE_URL_.__PS_BASE_URI__,
                'uuid' => $this->logdata['uuid'],
                'event_name' => !empty($this->logdata['event']) ? $this->logdata['event'] : $this->logdata['mode'],
                'log_type' => 'failure',
                'log_data' => $this->logdata,
                'created_at' => gmdate('d-m-Y H:i:s'),
                'platform' => "Prestashop"
            );

            $this->logRequest('https://autoforms.routee.net/u001/log.php', $postArr, 'POST');
        }
    }

    /**
     * @return int
     */
    public function eventType() {
        $type = 0;

        switch ($this->mode) {
            case "auth":
                $type = 1;
                break;
            case "massdata":
                $type = 3;
                break;
            case "events":
                $type = 2;
                break;
        }

        return $type;
    }

    /**
     * @param $url
     * @param $data
     * @param $method
     * @return array
     */
    public function logRequest($url, $data, $method)
    {
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 6,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $method,
            CURLOPT_HTTPHEADER => array("content-type: application/json"),
            CURLOPT_POSTFIELDS => json_encode($data)
        ));

        $curl_response = curl_exec($curl);
        $error = curl_error($curl);
        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);

        $flag = false;
        if (!$error && $code == 200) {
            $flag = true;
        }

        $response = array();
        $response["success"] = $flag;
        $response["data"] = array();
        $response["data"]["code"] = $code;
        $response["data"]["error"] = $error;
        $response["response"] = new stdClass();

        if (empty($curl_response)) {
            $response["response"]->message = 'Request timed out. Please find a better connection or try again later.';
        } else {
            $response["response"] = json_decode($curl_response);
        }

        return $response;
    }
}